proc initkin { obj ev filename } {
  return [vsAddObjFromFile $obj [vsWwwGetFile $filename]]
}

proc sendSetColor { obj ev userdata } {
  vsGetWorldInfo world avatar
  if { "$world" == "" || "$avatar" == "" } {
    return
  }

  catch { vsGetRegistry "AvatarColor\\$world\\$avatar" ret } ret2
  if { "$ret2" != "" } {
      set ret {{}}	
  }
  ############# Added by h.suigno 96/03/25 <-########
  if {"sleeping" == "[info global sleeping]"} {
    global sleeping
    if {0 == $sleeping} { 
        set fno 0
    } {
	set fno 12
    }
    lappend  ret  $fno
  } { 
    lappend  ret 0
  } 
  ############# added by h.suigno 96/03/25 ->########
  vscpSendSetAttribute [ vsGetPerson ] $ret
}

set initpersoncalled 0
proc initperson { obj ev userdata } {
  global initpersoncalled 
  if { $initpersoncalled == 1 } {
    return
  }
  set initpersoncalled 1
  global vsTclScript vsEvMyself vsEvSetAttribute 
  set person [ vsGetPerson ]
  vsAddEventHandler $person $vsEvMyself $vsTclScript "" "sendSetColor" "userdata"
}

proc recSetColor { obj ev userdata } {
  global vsTclScript vsSporadicTask
  vsGetEventData $ev retbuf
  vsAddTimeOutHandler $obj 1000 $vsTclScript "" "recSetColor1" "$retbuf" $vsSporadicTask
}

proc recSetColor1 { obj ev userdata } {
  SetPersonColor $obj $userdata
  ############# added by h.suigno 96/03/25 <-########
  if {"" != "[info command ActOnClients]"} {
      set arg [lindex $userdata 1]
      lappend arg {}
      ActOnClients $obj 0 $arg
      #vsMessageDlg "$arg $userdata"
  }
  ############# added by h.suigno 96/03/25 ->########
}

proc SetPersonColor {obj color} {

   ################ here is test code.

    global Colors  
    global vsDiffuse TargetUrl AvatarUrl

    set ret "$color"
    
#vsMessageDlg "ret:$ret"
    set ret [lindex $ret 0]
    unpackPersonColors "$ret"

    if {"" == [info global Colors]} {
	return ;
    }
    foreach d "[array names Colors]" { 
#vsMessageDlg "$d $Colors($d)"
	set part [vsGetObjByName $obj $d -r]
	if {$part} { 
	    eval "vsSetObjAllMaterial $part $vsDiffuse \
		    $Colors($d)"
	}
    }
}

proc _unpackPersonColors {str} { 
    set l [string length "$str"]
    if {$l < 3} { 
	return ""
    }
    set ret ""
    for {set i 0} {$i < 3} { incr i} {
	set c [string index "$str" $i]
	if { "$c" == "+" } {   
	    set v 1.0
	} { 
	    set v 0.$c
	}
	lappend ret $v
    }
    return "$ret"
}

########################################
# stř͎^
# 
# parts1 parts2 ... partsN
#
# parts : partname [0-9+][0-9+][0-9+]
#
# [0-9] ́A   0.X 
# +     ́A   1.0  \B
#
# global ColorsɒlԂB
#######################################

proc  unpackPersonColors {str} { 

    global Colors

    if {"" != "[info global Colors]"} {
	unset Colors
    }
    set l [llength "$str"]
    if { $l && [expr $l / 2] } { 
	incr l -1
    }
    for {set i 0} { $i < $l } { incr i } { 
	set part [lindex "$str" $i]
	incr i
	set color [_unpackPersonColors [lindex "$str" $i]]
	if {"" == "$color"} {
	    continue
	}
	set Colors($part) $color
    }
}
